function [ loglikM,loglikS, loglik_countM, loglik_countS, vmodel, vparam ] = fit_para( groupM,train_index,vname,lumpM,lumpS,index,only_count)
%UNTITLED Summary of this function goes here
%   index: the index of vname in lumpM.
%   e.g. :vname='RespRate';
%   might consider construct features only from subset of samples. 
%   loglik: likelihood of values
%   loglik_count: likelihood of counts of values

% distribution is fitted from groupM, physio values are from lumpM.

trainM=cell(length(train_index),1);
count=1;
for k=train_index
    trainM{count}=groupM{k};
    count=count+1;
end

temp_collect=[];
for k=train_index
    temp=groupM{k}{2}(strcmp(vname,groupM{k}{3}),2);
    temp_collect=vertcat(temp,temp_collect);
    temp_collect=temp_collect(temp_collect>0);
end

% if the values are missing at all. 
def_array=one_lump(trainM,vname,0);
def_numobs=cellfun(@length,def_array);
missing_prop=length(def_numobs(def_numobs==0))/length(def_numobs);

% fit the total counts of tests using poisson distribution.
% def_counts=def_numobs(def_numobs>0);
poiss_param=poissfit(def_numobs);

[loglikM,loglik_countM, cell_arrayM,numobsM]=get_loglik_count( lumpM,index,missing_prop,poiss_param);
[loglikS,loglik_countS, cell_arrayS,numobsS]=get_loglik_count( lumpS,index,missing_prop,poiss_param);

if only_count==0 || only_count==3
    % there're five candidate distributions, using groupM to fit.
    exp_param=expfit(temp_collect);
    exp_lik=explike(exp_param,temp_collect);

    logn_param = lognfit(temp_collect);
    logn_like=lognlike(logn_param,temp_collect);

    wbl_param = wblfit(temp_collect);
    wbl_like=wbllike(wbl_param,temp_collect);

    norm_param=mle(temp_collect);
    norm_like=normlike(norm_param,temp_collect);

    gam_param=gamfit(temp_collect);
    gam_like=gamlike(gam_param,temp_collect);

    vmodel=[exp_lik,logn_like,wbl_like,norm_like,gam_like];
    vparam=struct('exp',exp_param,'logn',logn_param,'wbl',wbl_param,'norm',norm_param,'gam',gam_param,'poisson',poiss_param);
    
    % select the distribution with minimum neg_loglik
    [temp, select]=min(vmodel);

    % neg_loglik of the values in lumpM using distributions fitted from groupM.
    
    [ loglikM ] = fit_obs( select, vparam, cell_arrayM, numobsM, loglikM, loglik_countM,only_count );
    [ loglikS ] = fit_obs( select, vparam, cell_arrayS, numobsS, loglikS, loglik_countS,only_count );
    
else
    
    loglikM=loglik_countM;
    loglikS=loglik_countS;
    
end

end

