function [ Y, X ,train_index, test_index] = get_feature_matrix( groupM, groupS, features, fold )
%UNTITLED2 Summary of this function goes here

tseries={'DiasABP','NISysABP','HR','Lactate','NIMAP','HCT','Platelets','WBC','Glucose','Na','K','Mg'};
both={'PaCO2','PaO2'};
labcount={'ALP','ALT','AST','Bilirubin','BUN','RespRate','HCO3','FiO2','Temp'};
discrete={'GCS'};
general={'Age','Weight'};
features=[tseries,both,labcount,discrete,general];
nfeatures=length(features);


% Y: the outcome of each patient, 1 for mortality, 0 for survival. 

lenM=length(groupM);
lenS=length(groupS);

testM_index=randsample(lenM,round(lenM/fold));
testS_index=randsample(lenS,round(lenS/fold));
trainM_index=setdiff(1:lenM,testM_index);
trainS_index=setdiff(1:lenS,testS_index);

lumpM=one_lump(groupM,features,1);
lumpS=one_lump(groupS,features,1);
% sizeM=cellfun(@length,lumpM);
% sizeS=cellfun(@length,lumpS);

temp1=zeros(lenM,50);
temp2=zeros(lenS,50);

Y(1:lenM)=1;
Y(lenM+1:lenM+lenS)=0;

MM=zeros(nfeatures-3,5);
SS=zeros(nfeatures-3,5);

count=1;
for vname=features(1:24)
    [loglikMM,loglikMS,loglik_countMM, loglik_countMS,MM(count,:),vparamM(count)]=fit_para(groupM,trainM_index,vname,lumpM,lumpS,count,3);
    [loglikSM,loglikSS,loglik_countSM, loglik_countSS,SS(count,:),vparamS(count)]=fit_para(groupS,trainS_index,vname,lumpM,lumpS,count,3);
    temp1(:,count)=(loglikSM-loglikMM);
    temp2(:,count)=(loglikSS-loglikMS);
    temp1(:,count+23)=(loglik_countSM-loglik_countMM);
    temp2(:,count+23)=(loglik_countSS-loglik_countMS);    
    
    count=count+1;
end

[ age1,age2,weight1,weight2,gcsM,gcsS ] = mis_variables( groupM,groupS );

temp1(:,47)=gcsM;
temp1(:,49)=age1;
temp1(:,50)=weight1;

temp2(:,47)=gcsS;
temp2(:,49)=age2;
temp2(:,50)=weight2;

X=zeros(lenM+lenS,50);
X(1:lenM,:)=temp1;
X(lenM+1:lenM+lenS,:)=temp2;

test_index=union(testM_index,testS_index+lenM);
train_index=union(trainM_index,trainS_index+lenM);

end

